=== debian/changelog ===
zhmcclient (0.21.0-0ubuntu1) disco; urgency=medium

  * Initial release (LP: #1805367)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 27 Nov 2018 18:55:21 +0000
