=== requirements.txt ===
# Pip requirements file for zhmcclient runtime dependencies.
#
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

# Make sure that the package versions in minimum-constraints.txt are also
# the minimum versions required in requirements.txt and dev-requirements.txt.


# Direct dependencies (except pip, setuptools, wheel):

decorator>=4.0.10 # new BSD
pbr>=1.10.0 # Apache-2.0
pytz>=2016.10 # MIT
requests>=2.20.0 # Apache-2.0
six>=1.10.0 # MIT
stomp.py>=4.1.15 # Apache


# Indirect dependencies (commented out, only listed to document their license):

# certifi # ISC, from requests>=2.20
# chardet # LGPL, from requests>=2.20
# idna # BSD-like, from requests>=2.20
# urllib3 # MIT, from requests>=2.20
