=== debian/changelog ===
zhmcclient (0.22.0-0ubuntu1) disco; urgency=medium

  * New upstream release

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 Jan 2019 11:25:20 +0000
