=== debian/control ===
Source: zhmcclient
Section: python
Priority: optional
Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
Build-Depends: debhelper (>= 11),
 dh-python,
 python3-all,
 python3-setuptools,
 python3-pytest,
 python3-requests,
 python3-decorator,
 python3-tz,
 python3-stomp,
 python3-requests-mock,
 python3-yaml,
 python3-testfixtures,
 python3-pbr,
 python3-mock,
Standards-Version: 4.1.3
Homepage: https://github.com/zhmcclient/python-zhmcclient
Testsuite: autopkgtest-pkg-python

Package: python3-zhmcclient
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: library for the IBM Z HMC Web Services API
 The HMC Web Services API is the access point for any external tools
 to manage the IBM Z or LinuxONE platform. It supports management of
 the lifecycle and configuration of various platform resources, such
 as partitions, CPU, memory, virtual switches, I/O adapters, and more.
 .
 The zhmcclient package encapsulates both protocols supported by the
 HMC Web Services API:
 .
 - REST over HTTPS for request/response-style operations driven by the
 client. Most of these operations complete synchronously, but some
 long-running tasks complete asynchronously.
 .
 - JMS (Java Messaging Services) for notifications from the HMC to the
 client. This is used for notification about changes in the system, or
 about completion of asynchronous tasks started using REST.
