=== debian/rules ===
#!/usr/bin/make -f
export PYBUILD_NAME=zhmcclient
export PYBUILD_TEST_PYTEST=1
export PYBUILD_BEFORE_TEST=cp PKG-INFO {build_dir}
export PYBUILD_AFTER_TEST=rm {build_dir}/PKG-INFO

%:
	dh $@ --with python3 --buildsystem=pybuild
