=== requirements.txt ===
--- 
+++ 
@@ -10,17 +10,17 @@
 
 # Direct dependencies (except pip, setuptools, wheel):
 
-decorator>=4.0.10 # new BSD
-pbr>=1.10.0 # Apache-2.0
+decorator>=4.0.11 # new BSD
 pytz>=2016.10 # MIT
-requests>=2.20.0 # Apache-2.0
-six>=1.10.0 # MIT
-stomp.py>=4.1.15 # Apache
-
+requests>=2.20.1 # Apache-2.0
+six>=1.14.0 # MIT
+stomp.py>=4.1.23,<5.0.0; python_version == '2.7'  # Apache
+stomp.py>=4.1.23; python_version > '2.7'  # Apache
 
 # Indirect dependencies (commented out, only listed to document their license):
 
 # certifi # ISC, from requests>=2.20
 # chardet # LGPL, from requests>=2.20
+# docopt # MIT, from stomp.py>=4.1
 # idna # BSD-like, from requests>=2.20
 # urllib3 # MIT, from requests>=2.20
