=== debian/changelog ===
zhmcclient (0.27.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release. LP: #1907536
  * Use github tarball
  * Do not run tests, needs HMC credentials

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 10 Dec 2020 16:46:54 +0000

zhmcclient (0.22.0-0ubuntu2) groovy; urgency=medium

  * Fix FTBFS by backporting a fix from upstream.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 05 Oct 2020 14:03:47 +1300
