=== debian/changelog ===
zhmcclient (0.31.0-0ubuntu3~20.04.1) focal; urgency=medium

  * Backporting new upstream release. (LP: #1919451)

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 22 Jul 2021 15:11:31 +0200
