=== debian/control ===
--- 
+++ 
@@ -22,7 +22,10 @@
 
 Package: python3-zhmcclient
 Architecture: all
-Depends: ${python3:Depends}, ${misc:Depends}
+Depends: python3-requests,
+ python3-decorator,
+ ${python3:Depends},
+ ${misc:Depends}
 Description: library for the IBM Z HMC Web Services API
  The HMC Web Services API is the access point for any external tools
  to manage the IBM Z or LinuxONE platform. It supports management of
