=== debian/changelog ===
zhmcclient (1.5.0-0ubuntu1) lunar; urgency=medium

  * New upstream release. LP: #2006944
  * Modify d/p/0001-Revert-Changed-properties-attribute-to-be-immutable.patch
    and transfer it into an independent patch:
    d/p/Changing-properties-attribute-back-to-be-not-immutable.patch since the
    changes for the latest version became far more than just reverting
    commit 5c24a01984ea95c03977e5b47f7f17eb33b0150f.
  * Remove './docs/_static/*.css' entry from d/copyright, since the referenced
    folder does not exist anymore.
  * Update 'Standards-Version' in d/control to latest 4.6.1.0.
  * Migrate debian/watch from version 3 to 4.
  * Update copyright years in debian/changelog.

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 09 Feb 2023 12:52:20 +0100

zhmcclient (0.31.0-0ubuntu3) impish; urgency=medium

  * d/control: fix armhf autopkgtest by adding python3-requests dependency

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 21 Jun 2021 18:16:51 +0200

zhmcclient (0.31.0-0ubuntu2) impish; urgency=medium

  * d/control: add python3-decorator runtime dependency
  * Add d/p/0001-Revert-Changed-properties-attribute-to-be-immutable.patch
    To avoid the new immutable_views dependency

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 21 Jun 2021 09:22:44 +0200

zhmcclient (0.31.0-0ubuntu1) impish; urgency=medium

  * New upstream release. LP: #1919451
  * Use github tarball

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Thu, 17 Jun 2021 19:13:32 -0500
