=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  python3-testfixtures,
  python3-pbr,
  python3-mock,
-Standards-Version: 4.1.3
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/zhmcclient/python-zhmcclient
 Testsuite: autopkgtest-pkg-python
